/*
 *	BI's JPEG decoder in OpenGL mode
 */

/*
 *  viewjpg.cpp
 *  
 */
#include "glos.h"
#include "parser.h"
#include <stdio.h>
#include <time.h>

#include <GL/gl.h>
#include <GL/glu.h>
#include <GL/glaux.h>

extern int Ximage,Yimage;
extern char* IMAGE;

void myinit(void);
void CALLBACK display(void);


void CALLBACK display(void)
{
    glClear(GL_COLOR_BUFFER_BIT);

    clock_t begin, end;
    begin=clock();
    glDrawPixels(Ximage,Yimage,GL_BGR_EXT,GL_UNSIGNED_BYTE,IMAGE);
    end=clock();
	printf("Show image time=%d ms\n", end-begin);

    glFlush();

}

void myinit (void) 
{
    glShadeModel (GL_FLAT);
}


/*  Main Loop
 *  Open window with initial window size, title bar, 
 *  BGR display mode, and handle input events.
 */
int main(int argc, char** argv)
{

    FILE* in;
    clock_t begin, end;

    char filename[128]="test1.jpg";
    Parser_class JPGparser;
    printf("input file: ");
    scanf("%s", filename);
    in=fopen(filename,"rb");
    if(in==NULL){
        printf("File %s does not exist!\n", filename);
        return 0;
    }
	
    begin=clock();
    JPGparser.decode(in);
	end=clock();
	printf("Decoder time=%d ms\n", end-begin);

    if(in!=NULL)
		fclose(in);

    auxInitDisplayMode (AUX_SINGLE | AUX_RGB);
    auxInitPosition (0, 0, JPGparser.Xsize, JPGparser.Ysize);
    auxInitWindow ("Jpeg decoder");
    
    myinit ();

    auxMainLoop(display);
    return(0);
}
